classdef TrapezoidalRule < MultiEvaluationFunctional
    
    methods
        function obj = TrapezoidalRule(N)
            if ~isscalar(N) || (N < 1)
                error('The argument N bust be a natural number.');
            end
            
            p = linspace(0, 1, N+1);
            dx = p(2) - p(1);
            w = dx*[0.5 ones(1, N-1) 0.5];
            
            obj@MultiEvaluationFunctional(p, w);
        end
    end
    
end

