clear all
close all
clc

P2 = MonomSystem(2);
P1 = HandleFunctionSystem(@(x) 1, @(x) x);


f1 = FunSysFunction(P2, [0 0 -1]); %f(x) = -x^2;
f2 = FunSysFunction(P1, [0 1]); %f(x) = x;
f3 = HandleFunction(@(x) 0.75); %f(x) = 3/4;

g = f1+f2+f3;

g.of(0) %Erwarteter Wert: 0.75
g.of(0.5) %Erwarteter Wert: 1
g.of(1) %Erwarteter Wert: 0.75

L1 = EvaluationFunctional(0);
L2 = EvaluationFunctional(0.5);
L3 = EvaluationFunctional(1);

P2.setFunctionals(L1, L2, L3);
P2.isIndependent() %Erwarteter Wert: 1

P1.setFunctionals(L1, L3);
P1.isIndependent() % Erwarteter Wert: 1

P3 = HandleFunctionSystem(@(x) 5, @(x) 42);
P3.setFunctionals(L1, L3);
P3.isIndependent() %Erwarteter Wert: 0

L = MultiEvaluationFunctional([0 0.5 1], [1 -1 1]);
L.of(g) %Erwarteter Wert: 0.5

T = TrapezoidalRule(10);
f = FunSysFunction(P2, [0 0 1]); %f(x) = x^2
T.of(f) %Erwarteter Wert: 0.3350

T = TrapezoidalRule(20);
f = HandleFunction(@(x) exp(x));
T.of(f) %Erwarteter Wert: 1.7186